﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.DayView;

namespace WS_SeletedTimeSlot
{
    class CustomDayViewDrawFilter :IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            AppearanceData appData = new AppearanceData();
            appData.BackColor = Color.Red;
            drawParams.DrawBackColor(ref appData, drawParams.Element.Rect, drawParams.Element.Rect, true);
            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is TimeSlotUIElement)
            {
                var timeSlotElement = drawParams.Element as TimeSlotUIElement;
                var dayView = timeSlotElement.Control as UltraDayView;
                var slot = timeSlotElement.GetContext() as TimeSlot;
                var date = timeSlotElement.Date.AddHours(slot.StartTime.Hour).AddMinutes(slot.StartTime.Minute);

                if (dayView.SelectedTimeSlotRange != null
                    && dayView.SelectedTimeSlotRange.StartDateTime <= date
                    && dayView.SelectedTimeSlotRange.EndDateTime >= date)
                {
                    return DrawPhase.None;
                }
                return DrawPhase.BeforeDrawBackColor;
               
            }
            else
            {
                return DrawPhase.None;
            }
        }
    }
}
