﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.TimelineView;

namespace WS_SeletedTimeSlot
{
    class CustomTimeLineViewDrawFilter : IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            AppearanceData appData = new AppearanceData();
            appData.BackColor = Color.Red;
            drawParams.DrawBackColor(ref appData,drawParams.Element.Rect, drawParams.Element.Rect, true);
            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is TimeSlotUIElement)
            {
                var timeSlot = drawParams.Element as TimeSlotUIElement;
                if (timeSlot.TimelineView.SelectedDateTimeRange != null &&
                    timeSlot.TimelineView.SelectedDateTimeRange.Contains(timeSlot.DateTimeRange))
                {
                    return DrawPhase.None;
                }
                return DrawPhase.BeforeDrawBackColor;
            }
            else
            {
                return DrawPhase.None;
            }
        }
    }
}
